'use strict';

angular.module('adf.widget.electre.lavoisier')
    .directive('lavoisierChartContent', [
        "domService", "lavoisierHttpRequestService", "LAVOISIER_TEMPLATES_PATH", "parserService",
        function (domService, lavoisierHttpRequestService, LAVOISIER_TEMPLATES_PATH, parserService) {

            function parseJSONForNgHighchart (json) {
                delete json.chart.renderTo;
                var retour = {};
                if (json.chart || json.drilldown || json.legend || json.labels || json.plotOptions || json.tooltip) {
                    retour.options = {};
                    if (json.chart)         retour.options.chart        = json.chart;
                    if (json.drilldown)     retour.options.drilldown    = json.drilldown;
                    if (json.labels)        retour.options.labels       = json.labels;
                    if (json.legend)        retour.options.legend       = json.legend;
                    if (json.plotOptions)   retour.options.plotOptions  = json.plotOptions;
                    if (json.tooltip)       retour.options.tooltip      = json.tooltip;
                }

                if (json.title)     retour.title        = json.title;
                if (json.subtitle)  retour.subtitle     = json.subtitle;
                if (json.xAxis)     retour.xAxis        = json.xAxis;
                if (json.series)    retour.series       = json.series;
                return retour;
            }

            return {
                scope : {
                    control : '='
                },
                link : function (scope, element, attrs) {
                    scope.control.processing();
                    scope.success = false; scope.failedRequest = false;

                    lavoisierHttpRequestService.getResult_2(scope.control.httpConfig)
                    .then(
                        function (value) {
                            var json = JSON.parse(parserService.xml_str2json(value).rendering);
                            try {
                                // scope.chartConfig = parseJSONForNgHighchart(json);
                                scope.chartConfig = json;
                                // scope.id = Date.now();
                            } catch (e) { scope.failedRequest = false; throw e; }
                        }, function (error) {
                            scope.failedRequest = true;
                            throw "An error has occurred during the request. Please verify you have entered valid info.";
                        }
                    ).then(
                        function () {
                            scope.control.success();
                            scope.success = true;
                        }, function (error) {
                            if (scope.failedRequest)    scope.control.requestFailed();
                            else                        scope.control.processingFailed();
                        }
                    );

                    scope.getTemplateUrl= function () {
                        if (scope.success)    return LAVOISIER_TEMPLATES_PATH + "/widgets/chart/directives/success.html";
                        else                  return false;
                    };
                },
                template : "<div ng-include='getTemplateUrl()'></div>"
            };
        }
    ]);